package net.northking.cctp.element.xml.enums;

import com.alibaba.fastjson.JSON;
import net.northking.cctp.element.core.type.EnumClass;

import java.util.*;

/**
 * TypeConversionEnum
 *
 * @author fengxiang.zhang
 * @since 1.0
 */
public enum TypeConversionSetEnum implements EnumClass {
    setFirstElementText("设置第一个元素的文本", "0"),
    setAllElementText("设置所有元素的文本", "1"),
    setFirstElementField("设置第一个元素的属性值", "2"),
    setAllElementField("设置所有元素的属性值", "3"),
    ;

    private String key;
    private String value;

    TypeConversionSetEnum(String key, String value) {
        this.key = key;
        this.value = value;
    }

    public static TypeConversionSetEnum from(String value) {
        for (TypeConversionSetEnum item : TypeConversionSetEnum.values()) {
            if (item.value.equals(value)) {
                return item;
            }
        }
        throw new IllegalArgumentException("未知的转换类型:" + value);
    }

    @Override
    public String getEnumData() {
        List<Map<String, Object>> result = new ArrayList<>();
        for (TypeConversionSetEnum item : EnumSet.allOf(TypeConversionSetEnum.class)) {
            Map<String, Object> one = new HashMap(1);
            one.put("label", item.key);
            one.put("value", item.value);
            result.add(one);
        }
        return JSON.toJSONString(result);
    }
}
